local core = LibStub("AceAddon-3.0"):GetAddon("tomQuest2")
local module = core:NewModule("tooltips", "AceHook-3.0")
local LT = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-Tooltip")
local defaults = {
	profile = {
		mobtooltip = true,
		itemtooltip = true,
	},
}

local prdb
function module:OnInitialize()
	self.db = core.db:RegisterNamespace("tooltips", defaults, "Default")
	prdb = self.db.profile
end

module.modName = LT["Tooltips"]
local options
function module:getOptions()
	if not options then
		options = {
			type = "group",
			name = module.modName,
			desc = module.modName,
			get = function(info) 
				return prdb[info[#info]]
			end,
			set = function(info, value)
				prdb[info[#info]] = value
			end,
			args = {
				mobtooltip = {
					name = LT["Toggle tooltip modification from mobs"],
					type = "toggle",
					width = "full",
					order = 10,
				},
				itemtooltip = {
					name = LT["Toggle tooltip modification from items"],
					type = "toggle",
					width = "full",
					order = 11,
				},
			},
		}
	end
	return options 
end

function module:OnEnable()
	self:HookScript(GameTooltip, "OnTooltipSetUnit")
	self:HookScript(GameTooltip, "OnTooltipSetItem")
end

function module:OnTooltipSetUnit(tooltip, ...)
	local name = tooltip:GetUnit()
	if name and core.questsMobs[name] and prdb.mobtooltip then
		for uid in pairs(core.questsMobs[name].quests) do
			tooltip:AddDoubleLine(format("|cffffffff%s|r", core.quests[uid].title), core.questsObjectives[uid][core.questsMobs[name].quests[uid]].qoStatus)
		end
	end
end

function module:OnTooltipSetItem(tooltip, ...)
	local name = tooltip:GetItem()
	if name and core.questsItems[name] and prdb.itemtooltip then
		for uid in pairs(core.questsItems[name].quests) do
			tooltip:AddDoubleLine(format("|cffffffff%s|r", core.quests[uid].title), core.questsObjectives[uid][core.questsItems[name].quests[uid]].qoStatus)
		end
	end
end